/**
 *  Generic example of master/worker program.
 *
 *  "Tasks" just consist of sleeping for a specified time; times to wait are
 *  generatedly randomly from 1 to a specified maximum.
 *
 *  Interface for worker process for client/server version using RMI.
 *
 *  RMI specifics in this example are loosely based on an example from 
 *  Sun's online tutorial.
 */
package csci3366.sample.masterworker.rmi;

import java.io.Serializable;
import java.rmi.Remote;
import java.rmi.RemoteException;

public interface WorkerInterface extends Remote, Serializable {
    String getHostName() throws RemoteException;
    int getID() throws RemoteException;
}
